<!doctype html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>Gradle</title>
    <meta name="description" content="Gradle workshop">
    <meta name="author" content="David McFarland">
    <meta name="apple-mobile-web-app-capable" content="yes"/>
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <link rel="stylesheet" href="css/reveal.min.css">
    <link rel="stylesheet" href="css/theme/moon.css" id="theme">
    <link rel="stylesheet" href="lib/css/zenburn.css">
    <link rel="stylesheet" href="css/slides.css">
</head>
<body>
<div class="reveal">
<div class="slides">

<section>
    <img style="border: none; background: none;box-shadow:none;width: 40%;" src="images/gradle-logo.png">

    <h3>Workshop -> 20-08-2014</h3>

    <p>WIFI SSID -> Instil-Public</p>

    <p>SSID KEY -> Blackjack7</p>

    <p>
        <small>Created by David McFarland using Reveal.js.</small>
    </p>
</section>

<section>
    <h3>Gradle Resources</h3>
    <ul>
        <li>
            <a href="http://gradle.org/docs/current/userguide/">Gradle User Guide</a>
        </li>
        <li>
            <a href="http://gradle.org/docs/current/dsl/">Gradle Build Language Reference</a>
        </li>
        <li>
            <a href="https://www.youtube.com/watch?v=5a91dBLX8Qc">Video presentation 'Rocking the Gradle with Hans Dockter'</a>
        </li>
        <li>
            <a href="http://www.gradle.org/learn">Buidling and testing with Gradle - Free ebook</a>
        </li>
    </ul>
    <img style="border: none; background: white;box-shadow:none;"
         src="images/building-and-testing-with-gradle-book.gif"/>
</section>

<section>
    <h2>Part 1</h2>

    <h3>The origin of builds</h3>
</section>

<section data-background="#ffffff">
    <img style="border: none; background: white;box-shadow:none;" src="images/ant-logo.png"/>
</section>


<section>
    <h2>Tasks</h2>
<pre><code data-trim>
<target name="compile" description="Compile source tree java files">
    <mkdir dir="${build.dir}"/>
    <javac destdir="${build.dir}" source="1.7" target="1.7">
        <src path="${src.dir}"/>
        <classpath refid="master-classpath"/>
    </javac>
</target>
</code></pre>
</section>


<section>
    <h2>Targets</h2>
<pre><code data-trim>
<project name="Hello World Project" default="greetTheWorld">
    <target name="greetTheWorld" depends="prepare">
        <echo>Hello World!</echo>
    </target>
    <target name="prepare">
        <echo>Preparing to greet the world...</echo>
    </target>
</project>
</code></pre>
</section>


<section data-background="#ffffff">
    <img style="border: none; background: white;box-shadow:none;" src="images/maven-logo.gif"/>
</section>


<section>
    <h2>Simple Maven Build</h2>
<pre><code data-trim>
<project>
    <modelVersion>4.0.0</modelVersion>
    <groupId>com.instil</groupId>
    <artifactId>BuildingWithMaven</artifactId>
    <packaging>jar</packaging>
    <version>0.1</version>
    <name>BuildingWithMaven</name>
    <dependencies>
        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>4.10</version>
            <scope>test</scope>
        </dependency>
    </dependencies>
</project>
</code></pre>
</section>

<section>
    <h2>Maven project convention</h2>
    <img style="border: none; background: white;box-shadow:none;height:260px;width:300px"
         src="images/maven-file.png"/>
</section>


<section>
    <h2>Maven repositories</h2>
    <img style="border: none; background: white;box-shadow:none;" src="images/search-maven-central.png"/>
</section>


<section>
    <h2>Maven repository layout</h2>
<pre><code data-trim>
    ├── archetype-catalog.xml
    ├── repository
    │   ├── antlr
    │   │   └── antlr
    │   │   ├── 2.7.2
    │   │   │   ├── _maven.repositories
    │   │   │   ├── antlr-2.7.2.jar
    │   │   │   ├── antlr-2.7.2.jar.sha1
    │   │   │   ├── antlr-2.7.2.pom
    │   │   │   └── antlr-2.7.2.pom.sha1
    │   │   ├── 2.7.6
    │   │   │   ├── _maven.repositories
    │   │   │   ├── antlr-2.7.6.jar
    │   │   │   ├── antlr-2.7.6.jar.sha1
    │   │   │   ├── antlr-2.7.6.pom
    │   │   │   └── antlr-2.7.6.pom.sha1
</code></pre>
</section>


<section data-background="#ffffff">
    <img style="border: none; background: white;box-shadow:none;" src="images/gradle-logo.png"/>
</section>


<section data-background="#ffffff">
    <h2 style="color: #333333;">Who's using Gradle</h2>
    <img style="border: none; background: white;box-shadow:none;" src="images/mockito-logo.jpg"/>
    <img style="border: none; background: white;box-shadow:none;" src="images/spring-logo.png"/>
    <img style="border: none; background: white;box-shadow:none;" src="images/hibernate-logo.png"/>
    <img style="border: none; background: white;box-shadow:none;" src="images/netflix-logo.jpeg"/>
    <img style="border: none; background: white;box-shadow:none;" src="images/android-logo.png"/>
    <img style="border: none; background: white;box-shadow:none;" src="images/linkedin-logo.png"/>
</section>

<section>
    <h2>Thoughtworks Technology Radar</h2>

    <p>Gradle - Adopt</p>

    <p>Maven - Proceed with caution</p>
    <blockquote>
        Language-based build tools like Gradle and Rake continue to offer finer-grained abstractions and more
        flexibility long term than XML and plug-in based tools like Ant and Maven. This allows them to grow
        gracefully
        as projects become more complex.
    </blockquote>
</section>

<section>
    <h2>Gradle wrapper overview</h2>

    <ul>
        <li>Gradle wrapper provides scripts which automatically download Gradle.</li>
        <li>The scripts should be checked into version control.</li>
        <li>They mean a developer doesn't need Gradle installed in order to build.</li>
        <li>Project is built with the same version of Gradle everywhere.</li>
    </ul>
<pre><code data-trim>
$ ./gradlew tasks
Downloading https://services.gradle.org/distributions/gradle-2.0-bin.zip
.....
------------------------------------------------------------
All tasks runnable from root project
------------------------------------------------------------

Build Setup tasks
-----------------
init - Initializes a new Gradle build. [incubating]
wrapper - Generates Gradle wrapper files. [incubating]
.....
</code></pre>
</section>

<section>
    <h2>Common commands</h2>
<pre><code data-trim>
// Specify buildfile to use.
$ ./gradlew -b solutions.gradle

// Specify multiple tasks
$ ./gradlew task1 task2

// Exclude task
$ ./gradlew task1 -x task2

// Speed up builds using daemon
$ ./gradlew --daemon task1

// Print debug level logging (-i for info) to console
$ ./gradlew --d task1

// Print list of tasks
$ ./gradlew tasks
</code></pre>
</section>

<section>
    <h2>Tasks</h2>

    <ul>
        <li>Tasks are the basic unit of work in Gradle.</li>
        <li>Tasks are a collection of actions.</li>
        <li>Task is a keyword in the Gradle build language.</li>
        <li>Task dependencies are described using 'dependsOn'.</li>
    </ul>

            <pre><code data-trim>
task hello << {
    println "Hello,"
}

task welcomeToTheGradleWorkshop(dependsOn: hello) {
    doLast {
        println "Welcome to the Gradle workshop!"
    }
}
            </code></pre>
</section>

<section>
    <h2>Executing Tasks</h2>
      <pre><code data-trim>
$ gradle welcomeToTheGradleWorkshop
Hello,
Welcome to the Gradle workshop!
      </code></pre>
    <br/>

    <h3>Abbreviated task</h3>
      <pre><code data-trim>
$ gradle wToTGraWop
Hello,
Welcome to the Gradle workshop!
      </code></pre>
    <br/>

    <h3>Exclude task</h3>
     <pre><code data-trim>
$ gradle welcomeToTheGradleWorkshop -x hello
Welcome to the Gradle workshop!
     </code></pre>
</section>

<section>
    <h2>Exercise 1 -
        <small>Task dependencies</small>
    </h2>
    <ol>
        <li>Go to exercises/exercise1 on command line or terminal.</li>
        <li>Run ./gradlew tasks
            <p>
                <small>N.B. Replace references to ./gradlew with gradlew.bat if on Windows</small>
            </p>
        </li>
        <li>Define task A to E with the following structure:
            <p>A <- B <- C -> D -> E</p>
        </li>
        <li>Run ./gradlew verify</li>
        <li>Run ./gradlew C successfully seeing all tasks run</li>
    </ol>
</section>

<section>
    <h2>Groovy Overview</h2>

    <p>Gradle uses Groovy to provide a concise language for describing builds.</p>

    <p>While initially you can approach the build.gradle file as a JSON-esque format
        for describing builds it is useful to have a high-level understanding of Groovy
        when you start reading and writing more complex build scripts.</p>
            <pre><code data-trim>
def list = [1, 2, 'hello']

def map = ['name':'James', 'location':'London']

def closure = { param -> println("Hello ${param}") }
closure.call("world!")

[1, 2, 3].each ({ item -> print "${item}-" })

def value = [1, 2, 3].collect { it * 2 }
assert value == [2, 4, 6]

"Over and under".replaceAll(/(.*)\sand(.*)/, "\$2\$1").equals("underOver")
            </code></pre>
</section>

<!--COMPLETE>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>-->

<section>
    <h2>Gradle Project</h2>

    <p>A gradle file configures a build model.</p>

    <p>At its root is a project object with properties and methods.</p>

    <img style="border: none; background: white;box-shadow:none;" src="images/project-task-api.png"/>
</section>

<section>
    <h2>Working with files</h2>
    <img style="border: none; background: white;box-shadow:none;" src="images/project-file-api.png"/>
        <pre><code data-trim>
// Access file relative to project root.
file('src/config.xml')

// Access files relative to project root.
files('src/file1.txt', new File('src/file2.txt'), 
      ['src/file3.txt', 'src/file4.txt'])
        </code></pre>
</section>


<section>
    <h2>Working with files</h2>
    Files in Gradle are GDK (Groovy Development Kit) files and come with lots of helpful methods not available on
    the JDK.
    <img style="border: none; background: white;box-shadow:none;" src="images/gdk-files.png"/>
            <pre><code data-trim>
file('config').eachFile {file ->
    println file.path
}
            </code></pre>
</section>

<section>
    <h2>Exercise 2 -
        <small>Groovy tasks</small>
    </h2>
    <ol>
        <li>Go to exercises/exercise2 on command line or terminal.</li>
        <li>Run ./gradlew verify
        <li>Add code to generate tasks for each 'yml' file in the config folder.</li>
        <p>Hint: Look at GDK File method eachFileMatch.</p>

        <p>Hint: A task name can be a string.</p>

        <p>Hint: Regex ^.*\.yml$ and \.[^\.]+$</p>
        <li>Run ./gradlew verify successfully</li>
    </ol>
</section>

<section>
    <h2>Incremental Builds</h2>

    <p>Task has two properties which support incremental builds.</p>
    <img style="border: none; background: white;box-shadow:none;" src="images/task-file-methods.png"/>
</section>

<section>
    <h2>Incremental Builds</h2>

    <p>These properties have methods for registering files and directories for observing changes.</p>
    <img style="border: none; background: white;box-shadow:none;" src="images/task-inputs.png"/>
</section>

<section>
    <h2>Exercise 3 -
        <small>Incremental builds</small>
    </h2>
    <ol>
        <li>Go to exercises/exercise3 on command line or terminal.</li>
        <li>Run ./gradlew longRunningTask</li>
        <li>Add code to support incremental builds:
            <ul>
                <li>The task should only run if database.db is modified</li>
            </ul>
        </li>
        <li>Run ./gradlew longRunningTask (it should run)</li>
        <li>Run ./gradlew longRunningTask (it should be marked as up-to-date)</li>
        <li>Change database.db and make sure that the task is rerun.</li>
    </ol>
</section>

<section>
    <h2>Build Lifecycle</h2>
    <ol>
        <li>Initialization:</li>
        <p>Configure environment and determine projects which will take part in the build.</p>
        <li>Configuration:</li>
        <p>Evaluate all projects' build scripts and create the build object model.</p>
        <li>Execution:</li>
        Determine the subset of tasks to be executed based on the DAG and execute them.
        <p></p>
    </ol>
</section>

<section>
    <h2>Plugins</h2>
    <ul>
        <li>Gradle is a language agnostic build tool.</li>
        <li>Plugins are micro extentions which add tasks and extend the Gradle DSL.</li>
        <li>Java support is provided by two plugins:
            <ul>
                <li>java-base - adds support for sourceSets i.e. capabilities</li>
                <li>java - adds support conventions i.e. src/main, src/test etc.</li>
            </ul>
        </li>
        <li><a href="http://www.gradle.org/docs/current/userguide/standard_plugins.html">Standard plugins
            documentation</a></li>
    </ul>
</section>

<section>
    <h2>Remote Plugins</h2>
    <ul>
        <li>Adding a simple plugin from a remote location</li>
<pre><code data-trim>
apply from: "https://dl.dropboxusercontent.com/u/19592085/git.gradle"
apply from: "https://dl.dropboxusercontent.com/u/19593333/company-standards.gradle"
</code></pre>

        <li>Adding a compiled plugin from a repository</li>
<pre><code data-trim>
buildscript {
    repositories {
        mavenCentral()
    }
    dependencies {
        classpath 'com.github.jengelman.gradle.plugins:shadow:0.8'
    }
}

apply plugin: 'shadow'
</code></pre>
    </ul>
</section>

<section>
    <h2>Exercise 4 -
        <small>Buildscript dependencies</small>
    </h2>
    <ol>
        <li>Go to exercises/exercise4 on command line or terminal.</li>
        <li>Run ./gradlew printMasterPassword</li>
        <li>The task is attempting to hash a password using guava (https://code.google.com/p/guava-libraries/)</li>
        <li>Add a closure to configure the buildscript classpath to contain closure.</li>
        <p>Hint: See previous slide.</p>

        <p>Hint: Use search.maven.org to find dependency information for guava.</p>
        <li>Run ./gradlew printMasterPassword successfully.</li>
    </ol>
</section>

<section>
    <h3>Java plugin</h3>
    <pre><code>
apply plugin: 'java'
    </code></pre>
    <p>The Java plugin adds all the common tasks you will use as part of a Java build.</p>
    <img style="border: none; background: white;box-shadow:none;" src="images/gradle-java-plugin.png"/>
</section>

<section>
    <h2>Java configurations</h2>
    <p>A Configuration is a container for artifacts and dependencies.</p>
    <img style="border: none; background: white;box-shadow:none;" src="images/java-configurations.png"/>
         <pre><code data-trim>
configurations {
    cucumberCompile.extendsFrom(testCompile)
}
     </code></pre>
</section>

<section>
    <h2>Project layout</h2>
    <img style="border: none; background: white;box-shadow:none;" src="images/default-source-dirs.png"/>

    <pre><code data-trim>
sourceSets {
    main {
        java {
            srcDir 'src/java'
        }
        resources {
            srcDir 'src/resources'
        }
    }
    cucumber
}
    </code></pre>
</section>

<section>
    <h2>Repositories</h2>

    <p>Gradle mandates you specify what repositories you intend to use.</p>

    <p>Both project and buildscript can have repository references.</p>
<pre><code data-trim>
repositories {
    mavenCentral()
    maven { url "http://repository-jongo.forge.cloudbees.com/release/" }
    jcenter()
}
</code></pre>
</section>

<section>
    <h2>Dependencies</h2>
<pre><code data-trim>
dependencies {
    compile 'org.jongo:jongo:1.1-early-20140221-1732'
    compile 'org.mongodb:mongo-java-driver:2.12.2'
    compile 'net.java.dev.jets3t:jets3t:0.9.0'

    testCompile 'org.hamcrest:hamcrest-all:1.3'

    cucumberCompile 'info.cukes:cucumber-groovy:1.1.7'
    cucumberCompile 'info.cukes:cucumber-junit:1.1.7'
    cucumberCompile 'info.cukes:cucumber-html:0.2.3'
    cucumberCompile 'info.cukes:gherkin:2.12.2'
}
</code></pre>
</section>

<section>
    <h2>Excluding dependencies</h2>
<pre><code data-trim>
configurations {
    compile.exclude module: 'commons'
    all*.exclude group: 'org.gradle.test.excludes', module: 'reports'
}

runtime('org.hibernate:hibernate:3.0.5') {
    transitive = true
}

compile("org.gradle.test.excludes:api:1.0") {
    exclude module: 'shared'
}
</code></pre>
</section>

<section>
    <h2>Exercise 5 -
        <small>Source sets</small>
    </h2>
    <ol>
        <li>Go to exercises/exercise5 on command line or terminal.</li>
        <li>Run ./gradlew build</li>
        <li>Add source set and configuration to get integration tests running.</li>
        <li>Fix integration test based on test report.</li>
        <li>Run ./gradlew htmlDependencyReport</li>
        <li>View report in build/reports/project/dependencies/index.html</li>
        <li>Add checkstyle, pmd and findbugs plugins to build.</li>
    </ol>
</section>

<section>
    <h2>JavaExec</h2>

    <p>As with Ant it is trivial to execute Java programs. </p>
<pre><code data-trim>
task cucumber(type: JavaExec, dependsOn: [startDropwizard], description: "Start CIP application") {
    classpath = project.sourceSets.main.runtimeClasspath + project.sourceSets.cucumber.runtimeClasspath +
    sourceSets.main.output + sourceSets.test.output + sourceSets.cucumber.output
    main = "cucumber.api.cli.Main"
    args = ['-f', 'pretty', '--glue', 'src/cucumber/groovy', 'src/cucumber/resources/features']
}
</code></pre>
</section>

<section>
    <h2>JavaFork</h2>

    <p>And a variant which doesn't block - ideal for integration testing.</p>
<pre><code data-trim>
// Add following class to buildscript config.
classpath 'com.github.jengelman.gradle.plugins:gradle-processes:0.2'

/******************
* Starting and stopping dropwizard as a daemon process.
******************/
task startDropwizard(type: com.github.jengelman.gradle.plugins.processes.tasks.JavaFork, dependsOn: test,
    description: "Start development application (using config/dev.yml)") {
    classpath sourceSets.main.runtimeClasspath
    main = "co.instil.OverseerService"
    args = ["server", "config/dev.yml"]
}

task stopDropwizard << {
    startDropwizard.processHandle.abort()
}
</code></pre>
</section>

<section>
    <h2>IDE Plugins</h2>

    <p>Gradle provides plugins to generate project files for IntelliJ and Eclipse.</p>

    <p>When using additional source directories a little additional configuration is required to register the new source
        sets.</p>
<pre><code data-trim>
apply plugin: 'idea'
idea {
    module {
        testSourceDirs += sourceSets.cucumber.java.srcDirs
        testSourceDirs += sourceSets.cucumber.resources.srcDirs
        scopes.TEST.plus += configurations.cucumberCompile
    }
}
</code></pre>
</section>

<section>
    <h2>Customizing the wrapper</h2>

    <p>Sometimes your build requires additional JVM options.</p>
<pre><code data-trim>
/******************
* Gradle wrapper configuration.
******************/
task wrapper(type: Wrapper, description: 'Generate Gradle wrapper') {
    gradleVersion = '1.12'
    def jvmOpts = "-Xmx512m"
    inputs.property("jvmOpts", jvmOpts)
    doLast {
        def optsEnvVar = "DEFAULT_JVM_OPTS"
        scriptFile.write scriptFile.text.replace("$optsEnvVar=\"\"", "$optsEnvVar=\"$jvmOpts\"")
        batchScript.write batchScript.text.replace("set $optsEnvVar=", "set $optsEnvVar=$jvmOpts")
    }
}
</code></pre>
</section>

<!--
Generate project dependencies report using - apply plugin: 'project-report'
./gradlew -Dtest.single=OperatorServiceTest test
-->

<section>
    <h2>The END.</h2>

    <p>Thanks for attending.</p>
</section>
</div>
</div>
<script src="lib/js/head.min.js"></script>
<script src="js/reveal.min.js"></script>
<script>
    Reveal.initialize({
        controls: false,
        progress: true,
        history: true,
        center: true,

        margin: -0.05,
        minScale: 0.9,
        maxScale: 1.0,
        theme: Reveal.getQueryHash().theme,
        transition: Reveal.getQueryHash().transition || 'default',
        dependencies: [
            {
                src: 'lib/js/classList.js', condition: function () {
                return !document.body.classList;
            }
            },
            {
                src: 'plugin/markdown/marked.js', condition: function () {
                return !!document.querySelector('[data-markdown]');
            }
            },
            {
                src: 'plugin/markdown/markdown.js', condition: function () {
                return !!document.querySelector('[data-markdown]');
            }
            },
            {
                src: 'plugin/highlight/highlight.js', async: true, callback: function () {
                hljs.initHighlightingOnLoad();
            }
            },
            {
                src: 'plugin/zoom-js/zoom.js', async: true, condition: function () {
                return !!document.body.classList;
            }
            },
            {
                src: 'plugin/notes/notes.js', async: true, condition: function () {
                return !!document.body.classList;
            }
            }
        ]
    });
</script>
</body>
</html>